diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/point-to-point/bindings/modulegen__gcc_LP64.py ns-3.36/src/point-to-point/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/point-to-point/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/point-to-point/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:58.126734700 -0700
@@ -5686,10 +5701,16 @@
     cls.add_method('ExtractNeighborIndex', 
                    'uint32_t', 
                    [param('uint32_t', 'numberOfBits')])
-    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() [member function]
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetEpoch() const [member function]
+    cls.add_method('GetEpoch', 
+                   'uint32_t', 
+                   [], 
+                   is_const=True)
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() const [member function]
     cls.add_method('GetRemainingBits', 
                    'uint32_t', 
-                   [])
+                   [], 
+                   is_const=True)
     ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
@@ -5700,6 +5721,10 @@
                    'uint32_t', 
                    [param('uint32_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
+    ## nix-vector.h (module 'network'): void ns3::NixVector::SetEpoch(uint32_t epoch) [member function]
+    cls.add_method('SetEpoch', 
+                   'void', 
+                   [param('uint32_t', 'epoch')])
     return
 
 def register_Ns3Node_methods(root_module, cls):
@@ -6076,10 +6101,11 @@
                    'uint32_t', 
                    [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
-    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
+    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) const [member function]
     cls.add_method('SetNixVector', 
                    'void', 
-                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
+                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')], 
+                   is_const=True)
     ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
     cls.add_method('ToString', 
                    'std::string', 
@@ -6206,11 +6232,11 @@
     cls.add_method('Attach', 
                    'bool', 
                    [param('ns3::Ptr< ns3::PointToPointChannel >', 'ch')])
-    ## point-to-point-net-device.h (module 'point-to-point'): void ns3::PointToPointNetDevice::SetQueue(ns3::Ptr<ns3::Queue<ns3::Packet> > queue) [member function]
+    ## point-to-point-net-device.h (module 'point-to-point'): void ns3::PointToPointNetDevice::SetQueue(ns3::Ptr<ns3::Queue<ns3::Packet>> queue) [member function]
     cls.add_method('SetQueue', 
                    'void', 
                    [param('ns3::Ptr< ns3::Queue< ns3::Packet > >', 'queue')])
-    ## point-to-point-net-device.h (module 'point-to-point'): ns3::Ptr<ns3::Queue<ns3::Packet> > ns3::PointToPointNetDevice::GetQueue() const [member function]
+    ## point-to-point-net-device.h (module 'point-to-point'): ns3::Ptr<ns3::Queue<ns3::Packet>> ns3::PointToPointNetDevice::GetQueue() const [member function]
     cls.add_method('GetQueue', 
                    'ns3::Ptr< ns3::Queue< ns3::Packet > >', 
                    [], 
@@ -6681,7 +6707,7 @@
     cls.add_constructor([param('ns3::ReceiveListErrorModel const &', 'arg0')])
     ## error-model.h (module 'network'): ns3::ReceiveListErrorModel::ReceiveListErrorModel() [constructor]
     cls.add_constructor([])
-    ## error-model.h (module 'network'): std::list<unsigned int, std::allocator<unsigned int> > ns3::ReceiveListErrorModel::GetList() const [member function]
+    ## error-model.h (module 'network'): std::list<unsigned int, std::allocator<unsigned int>> ns3::ReceiveListErrorModel::GetList() const [member function]
     cls.add_method('GetList', 
                    'std::list< unsigned int >', 
                    [], 
@@ -6691,7 +6717,7 @@
                    'ns3::TypeId', 
                    [], 
                    is_static=True)
-    ## error-model.h (module 'network'): void ns3::ReceiveListErrorModel::SetList(std::list<unsigned int, std::allocator<unsigned int> > const & packetlist) [member function]
+    ## error-model.h (module 'network'): void ns3::ReceiveListErrorModel::SetList(std::list<unsigned int, std::allocator<unsigned int>> const & packetlist) [member function]
     cls.add_method('SetList', 
                    'void', 
                    [param('std::list< unsigned int > const &', 'packetlist')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/point-to-point/CMakeLists.txt ns-3.36/src/point-to-point/CMakeLists.txt
--- ns-3.35/src/point-to-point/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/point-to-point/CMakeLists.txt	2022-04-30 18:23:58.126734700 -0700
@@ -0,0 +1,36 @@
+set(mpi_sources)
+set(mpi_headers)
+set(mpi_libraries)
+
+if(${ENABLE_MPI})
+  set(mpi_sources
+      model/point-to-point-remote-channel.cc
+  )
+  set(mpi_headers
+      model/point-to-point-remote-channel.h
+  )
+  set(mpi_libraries
+      ${libmpi}
+      ${MPI_CXX_LIBRARIES}
+  )
+  include_directories(${MPI_CXX_INCLUDE_DIRS})
+endif()
+
+build_lib(
+  LIBNAME point-to-point
+  SOURCE_FILES
+    ${mpi_sources}
+    helper/point-to-point-helper.cc
+    model/point-to-point-channel.cc
+    model/point-to-point-net-device.cc
+    model/ppp-header.cc
+  HEADER_FILES
+    ${mpi_headers}
+    helper/point-to-point-helper.h
+    model/point-to-point-channel.h
+    model/point-to-point-net-device.h
+    model/ppp-header.h
+  LIBRARIES_TO_LINK ${libnetwork}
+                    ${mpi_libraries}
+  TEST_SOURCES test/point-to-point-test.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/point-to-point/examples/CMakeLists.txt ns-3.36/src/point-to-point/examples/CMakeLists.txt
--- ns-3.35/src/point-to-point/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/point-to-point/examples/CMakeLists.txt	2022-04-30 18:23:58.126734700 -0700
@@ -0,0 +1,6 @@
+build_lib_example(
+  NAME main-attribute-value
+  SOURCE_FILES main-attribute-value.cc
+  LIBRARIES_TO_LINK ${libnetwork}
+                    ${libpoint-to-point}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/point-to-point/helper/point-to-point-helper.cc ns-3.36/src/point-to-point/helper/point-to-point-helper.cc
--- ns-3.35/src/point-to-point/helper/point-to-point-helper.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/point-to-point/helper/point-to-point-helper.cc	2022-04-30 18:23:58.130735000 -0700
@@ -47,6 +47,7 @@
   m_queueFactory.SetTypeId ("ns3::DropTailQueue<Packet>");
   m_deviceFactory.SetTypeId ("ns3::PointToPointNetDevice");
   m_channelFactory.SetTypeId ("ns3::PointToPointChannel");
+  m_enableFlowControl = true;
 }
 
 void 
@@ -77,6 +78,12 @@
   m_channelFactory.Set (n1, v1);
 }
 
+void
+PointToPointHelper::DisableFlowControl (void)
+{
+  m_enableFlowControl = false;
+}
+
 void 
 PointToPointHelper::EnablePcapInternal (std::string prefix, Ptr<NetDevice> nd, bool promiscuous, bool explicitFilename)
 {
@@ -240,13 +247,16 @@
   b->AddDevice (devB);
   Ptr<Queue<Packet> > queueB = m_queueFactory.Create<Queue<Packet> > ();
   devB->SetQueue (queueB);
-  // Aggregate NetDeviceQueueInterface objects
-  Ptr<NetDeviceQueueInterface> ndqiA = CreateObject<NetDeviceQueueInterface> ();
-  ndqiA->GetTxQueue (0)->ConnectQueueTraces (queueA);
-  devA->AggregateObject (ndqiA);
-  Ptr<NetDeviceQueueInterface> ndqiB = CreateObject<NetDeviceQueueInterface> ();
-  ndqiB->GetTxQueue (0)->ConnectQueueTraces (queueB);
-  devB->AggregateObject (ndqiB);
+  if (m_enableFlowControl)
+    {
+      // Aggregate NetDeviceQueueInterface objects
+      Ptr<NetDeviceQueueInterface> ndqiA = CreateObject<NetDeviceQueueInterface> ();
+      ndqiA->GetTxQueue (0)->ConnectQueueTraces (queueA);
+      devA->AggregateObject (ndqiA);
+      Ptr<NetDeviceQueueInterface> ndqiB = CreateObject<NetDeviceQueueInterface> ();
+      ndqiB->GetTxQueue (0)->ConnectQueueTraces (queueB);
+      devB->AggregateObject (ndqiB);
+    }
 
   Ptr<PointToPointChannel> channel = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/point-to-point/helper/point-to-point-helper.h ns-3.36/src/point-to-point/helper/point-to-point-helper.h
--- ns-3.35/src/point-to-point/helper/point-to-point-helper.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/point-to-point/helper/point-to-point-helper.h	2022-04-30 18:23:58.130735000 -0700
@@ -100,6 +100,16 @@
   void SetChannelAttribute (std::string name, const AttributeValue &value);
 
   /**
+   * Disable flow control only if you know what you are doing. By disabling
+   * flow control, this NetDevice will be sent packets even if there is no
+   * room for them (such packets will be likely dropped by this NetDevice).
+   * Also, any queue disc installed on this NetDevice will have no effect,
+   * as every packet enqueued to the traffic control layer queue disc will
+   * be immediately dequeued.
+   */
+  void DisableFlowControl (void);
+
+  /**
    * \param c a set of nodes
    * \return a NetDeviceContainer for nodes
    *
@@ -184,6 +194,7 @@
   ObjectFactory m_queueFactory;         //!< Queue Factory
   ObjectFactory m_channelFactory;       //!< Channel Factory
   ObjectFactory m_deviceFactory;        //!< Device Factory
+  bool m_enableFlowControl;             //!< whether to enable flow control
 };
 
 } // namespace ns3
